&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DECLARATIONS C-Win 
using dotr.Maia.Model.*.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

create widget-pool.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
def var lv_Original as longchar no-undo.
def var lv_template as longchar no-undo.

def var lv_Indicator as char case-sensitive no-undo.
  
def var lv_TypeLen as  int  no-undo extent 10.

def var lv_Callback as handle no-undo.

def temp-table TTIndex no-undo    
  field IndexName      as char
  field parametersIn   as char
  field parametersCall as char
  field FindString     as char 
  
  index main is primary unique 
    IndexName 
  .
    
def temp-table TTField no-undo
  field FieldName as char
  field PropertyName as char
  field GenerateNextValue as logical
  field SequenceName as char
  field GenerateGUId as logical
  field DataType as char
  field extent as int
  field GeneratorField as class Progress.Lang.Object
  
  index DataType is primary
    DataType
    FieldName.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-35 RECT-36 RECT-37 Combo_DB ~
fillin_Prefix fillin_Suffix ToggleActiveRecord ToggleEnum ~
ToggleUIMaintenance ToggleLookup SELECT-1 Btn_OK 
&Scoped-Define DISPLAYED-OBJECTS Combo_DB fillin_Prefix fillin_Suffix ~
ToggleActiveRecord ToggleEnum ToggleUIMaintenance ToggleLookup SELECT-1 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
define var C-Win as widget-handle no-undo.

/* Definitions of the field level widgets                               */
define button Btn_OK auto-go 
     label "&Build" 
     size 15 by 1.14
     bgcolor 8 .

define variable Combo_DB as character format "X(256)":U 
     label "&DB" 
     view-as combo-box sort inner-lines 5
     drop-down-list
     size 48 by 1 no-undo.

define variable fillin_Prefix as character format "X(256)":U 
     label "&Prefix" 
     view-as fill-in 
     size 14 by 1 no-undo.

define variable fillin_Suffix as character format "X(256)":U 
     label "&Suffix" 
     view-as fill-in 
     size 15 by 1 no-undo.

define rectangle RECT-35
     edge-pixels 2 graphic-edge  no-fill   
     size 60 by 2.81.

define rectangle RECT-36
     edge-pixels 2 graphic-edge  no-fill   
     size 60 by 3.05.

define rectangle RECT-37
     edge-pixels 2 graphic-edge  no-fill   
     size 60 by 17.57.

define variable SELECT-1 as character 
     view-as selection-list multiple sort scrollbar-vertical 
     size 56 by 16.43 no-undo.

define variable ToggleActiveRecord as logical initial yes 
     label "Active Record" 
     view-as toggle-box
     size 22 by .81 no-undo.

define variable ToggleEnum as logical initial no 
     label "Enum" 
     view-as toggle-box
     size 13 by .81 no-undo.

define variable ToggleLookup as logical initial no 
     label "Lookup" 
     view-as toggle-box
     size 13 by .81 no-undo.

define variable ToggleUIMaintenance as logical initial no 
     label "Maintenance Screens" 
     view-as toggle-box
     size 26 by .81 no-undo.


/* ************************  Frame Definitions  *********************** */

define frame DEFAULT-FRAME
     Combo_DB at row 1.95 col 12 colon-aligned widget-id 12
     fillin_Prefix at row 3.14 col 12 colon-aligned widget-id 16
     fillin_Suffix at row 3.14 col 45 colon-aligned widget-id 14
     ToggleActiveRecord at row 5.76 col 6 widget-id 18
     ToggleEnum at row 5.76 col 42 widget-id 22
     ToggleUIMaintenance at row 6.71 col 6 widget-id 20
     ToggleLookup at row 6.71 col 42 widget-id 24
     SELECT-1 at row 9.33 col 6 no-label widget-id 2
     Btn_OK at row 26.48 col 49 widget-id 8
     " Tables" view-as text
          size 9 by .62 at row 8.38 col 5 widget-id 38
     " Table Options" view-as text
          size 15 by .62 at row 1.24 col 5 widget-id 34
     " Templates" view-as text
          size 11 by .62 at row 4.81 col 5 widget-id 30
     RECT-35 at row 5.1 col 4 widget-id 28
     RECT-36 at row 1.52 col 4 widget-id 32
     RECT-37 at row 8.67 col 4 widget-id 36
    with 1 down no-box keep-tab-order overlay 
         side-labels no-underline three-d 
         at col 1 row 1
         size 64.6 by 27.1 widget-id 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
if session:display-type = "GUI":U then
  create window C-Win assign
         hidden             = yes
         title              = "Generate Models From Table"
         height             = 27.05
         width              = 64
         max-height         = 35.52
         max-width          = 144.8
         virtual-height     = 35.52
         virtual-width      = 144.8
         resize             = yes
         scroll-bars        = no
         status-area        = no
         bgcolor            = ?
         fgcolor            = ?
         keep-frame-z-order = yes
         three-d            = yes
         message-area       = no
         sensitive          = yes.
else {&WINDOW-NAME} = current-window.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
if session:display-type = "GUI":U and VALID-HANDLE(C-Win)
then C-Win:hidden = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
on end-error of C-Win /* Generate Models From Table */
or endkey of {&WINDOW-NAME} anywhere do:
  /* This case occurs when the PlaceHolder presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  if this-procedure:persistent then return no-apply.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
on window-close of C-Win /* Generate Models From Table */
do:
  /* This event will close the window and terminate the procedure.  */
  apply "CLOSE":U to this-procedure.
  return no-apply.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK C-Win
on choose of Btn_OK in frame DEFAULT-FRAME /* Build */
do:
  def var lv_i as int no-undo.
  def var lv_j as int no-undo.
  
  def var lv_table  as char no-undo.
  def var lv_Config as char no-undo.
     
  def var ObjectConfig1 as class ObjectConfig no-undo.
  
  def var ObjectBuilder1 as dotr.Maia.Builder.ObjectBuilder no-undo.
   
  assign Select-1 fillin_prefix fillin_Suffix.

  ObjectBuilder1 = dotr.Maia.Builder.ObjectBuilder:Instance.
  
  do lv_i = 1 to num-entries(Select-1):
    assign lv_table  = entry(lv_i,Select-1)
           lv_Config = lv_Table. 

    if fillin_prefix gt "" and lv_Config begins fillin_prefix 
         then assign lv_Config = substr(lv_Config,length(fillin_prefix) + 1).              

    if fillin_Suffix gt "" and r-index(lv_Config,fillin_suffix) gt 0 
         then lv_Config = substring(lv_Config,1,length(lv_Config) - length(fillin_Suffix)).              
    
    ObjectConfig1 = ObjectConfig:Get(dotr.Maia.CurrentProject:GetConfigFile(lv_Config)) no-error.

    if ObjectConfig1:ClassName eq "" then 
    do:
      assign ObjectConfig1:ClassName = lv_Table
             ObjectConfig1:TableName = lv_Table.
    end.
    
    ObjectConfig1:LogicalDb = Combo_DB:screen-value.
    
    if ToggleActiveRecord:checked  then ObjectConfig1:AddTemplate("ActiveRecord.i,ActiveRecordBase.i,ActiveRecordHelper.i,ActiveRecordHelperBase.i").
    if ToggleEnum:checked          then ObjectConfig1:AddTemplate("enum.i").
    if ToggleLookup:checked        then ObjectConfig1:AddTemplate("lookup.i").
    if ToggleUIMaintenance:checked then ObjectConfig1:AddTemplate("BaseRibbon.i,BaseUpdate.i,Ribbon.i,Update.i").
    
    if fillin_prefix gt "" and ObjectConfig1:ClassName begins fillin_prefix 
         then assign ObjectConfig1:ClassName = substr(ObjectConfig1:ClassName,length(fillin_prefix) + 1).              

    if fillin_Suffix gt "" and r-index(ObjectConfig1:ClassName,fillin_suffix) gt 0 
         then ObjectConfig1:ClassName = substring(ObjectConfig1:ClassName,1,length(ObjectConfig1:ClassName) - length(fillin_Suffix)).              
    
    (new dotr.Maia.Builder.DBProperties()):GetDBProperties(ObjectConfig1).  

    ObjectConfig1:Save().
  end.
  
  message "generation done" view-as alert-box information.
  
  if valid-handle(lv_Callback) then run "refresh" in lv_Callback.
  
  apply "close" to this-procedure.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Combo_DB
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Combo_DB C-Win
on value-changed of Combo_DB in frame DEFAULT-FRAME /* DB */
do:
  def var ObjectConfig1 as ObjectConfig no-undo.
  
  def var lv_Query  as handle no-undo.
  def var lv_Buffer as handle no-undo.
  
  def var ObjectBuilder1 as dotr.Maia.Builder.ObjectBuilder no-undo.
  
  delete alias DICTDB.
  create alias DICTDB for database value(Combo_DB:screen-value).
  
  assign Select-1:LIST-ITEMS   = ""
         Select-1:screen-value = "".
  
  create query lv_Query.
  create buffer lv_Buffer for table substitute("&1._File",Combo_DB:screen-value).
   
  lv_Query:add-buffer(lv_Buffer).
  
  lv_Query:query-prepare(substitute("FOR each &1._File no-lock where &1._File._file-number GT 0 and &1._File._file-number LT 1000 BY &1._File._File-name",Combo_DB:screen-value)).
  lv_Query:query-open().
  lv_Query:GET-FIRST().
  
  ObjectBuilder1 = dotr.Maia.Builder.ObjectBuilder:Instance.
  
  do while not lv_Query:query-OFF-END:
    Select-1:ADD-LAST(lv_Buffer::_File-name) in frame {&FRAME-NAME}.
    
    ObjectConfig1 = ObjectConfig:Get(dotr.Maia.CurrentProject:GetConfigFile(lv_Buffer::_File-name)) no-error.
    
    if ObjectConfig1:ClassName ne "" then assign Select-1 = select-1 + "," + lv_Buffer::_File-name.
    delete object ObjectConfig1.
    lv_Query:get-next().
  end.
  
  lv_Query:query-close().
  delete object lv_Query.
  delete object lv_buffer.
  delete object ObjectBuilder1.
  
  assign Select-1 = left-trim(Select-1,",").
  Select-1:Screen-value = Select-1. 
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
assign CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-procedure:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
on close of this-procedure 
   run disable_UI.

/* Best default for GUI applications is...                              */
pause 0 before-hide.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
do on error   undo MAIN-BLOCK, leave MAIN-BLOCK
   on end-key undo MAIN-BLOCK, leave MAIN-BLOCK:
  
  run StartUp.

  run enable_UI.
  if not this-procedure:persistent then
    wait-for close of this-procedure.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
procedure disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  if session:display-type = "GUI":U and VALID-HANDLE(C-Win)
  then delete widget C-Win.
  if this-procedure:persistent then delete procedure this-procedure.
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
procedure enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  display Combo_DB fillin_Prefix fillin_Suffix ToggleActiveRecord ToggleEnum 
          ToggleUIMaintenance ToggleLookup SELECT-1 
      with frame DEFAULT-FRAME in window C-Win.
  enable RECT-35 RECT-36 RECT-37 Combo_DB fillin_Prefix fillin_Suffix 
         ToggleActiveRecord ToggleEnum ToggleUIMaintenance ToggleLookup 
         SELECT-1 Btn_OK 
      with frame DEFAULT-FRAME in window C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  view C-Win.
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE SetCallBack C-Win 
procedure SetCallBack :
/*------------------------------------------------------------------------------
                        Purpose:                                                                                                                                          
                        Notes:                                                                                                                                            
        ------------------------------------------------------------------------------*/
  def input parameter p_Callback as handle no-undo.
  
  assign lv_CallBack = p_Callback.

end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE StartUp C-Win 
procedure StartUp :
/*------------------------------------------------------------------------------
                        Purpose:                                                                                                                                          
                        Notes:                                                                                                                                            
        ------------------------------------------------------------------------------*/

  
  def var lv_i as int no-undo.
  
  do lv_i = 1 to num-dbs:
    Combo_DB:ADD-LAST(ldbname(lv_i)) in frame {&frame-name}.
  end.

  return.
    
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

