
/*
 Dot R Limited  CONFIDENTIAL
 Unpublished Copyright (c) 2011 Dot R Limited, All Rights Reserved.

 NOTICE:  All information contained herein is, and remains the property of Dot R Limited. The intellectual and technical concepts contained
 herein are proprietary to Dot R Limited and are protected by trade secret or copyright law.
 Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
 from Dot R Limited.  Access to the source code contained herein is hereby forbidden to anyone except current Dot R Limited employees, managers or contractors who have executed 
 Confidentiality and Non-disclosure agreements explicitly covering such access.

 The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
 information that is confidential and/or proprietary, and is a trade secret, of  Dot R Limited.   
 
 ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, OR PUBLIC DISPLAY OF OR THROUGH USE OF THIS SOURCE CODE 
 WITHOUT THE EXPRESS WRITTEN CONSENT OF Dot R Limited IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE LAWS AND INTERNATIONAL TREATIES.  
 THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
 TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.
*/


using Progress.Lang.*.
using Progress.Data.*.

routine-level on error undo, throw.

class dotr.Maia.Helper.PlaceHolder:
  
  /** gets a PlaceHolder using FindUsingDialPlanGUID
   *
   * @param  p_DialPlanGUID - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingDialPlanGUID( p_DialPlanGUID as character):
  end method.
  
  /** gets a PlaceHolder using FindUsingPlaceHolder
   *
   * @param  p_PlaceHolder - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingPlaceHolder( p_PlaceHolder as character):
  end method.
  
  /** gets a PlaceHolder using FindUsingPlaceHolderGUID
   *
   * @param  p_PlaceHolderGUID - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingPlaceHolderGUID( p_PlaceHolderGUID as character):
  end method.
  
  /** gets a PlaceHolder using FindUsingExternalNumber
   *
   * @param  p_ExternalNumber - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingExternalNumber( p_ExternalNumber as character):
  end method.
  
  /** gets a PlaceHolder using FindUsingFirstName
   *
   * @param  p_FirstName - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingFirstName( p_FirstName as character):
  end method.
  
  /** gets a PlaceHolder using FindUsingLastName
   *
   * @param  p_LastName - character
   * @return dotr.Maia.Model.PlaceHolder
   */
  method public static dotr.Maia.Model.PlaceHolder FindUsingLastName( p_LastName as character):
  end method.
  
    
  method public static dotr.Maia.Model.PlaceHolder FindWhere(p_Query as char):
  end method.
  
  /** gets the PlaceHolder matching the unique ID 
   *  @param p_PlaceHolderID : the id to find
   */

  method public static dotr.Maia.Model.PlaceHolder find(p_PlaceHolderID as char):
  end.
  
  /** open a query for all records in the <<Table>> table
   */
  method public static dotr.Maia.Model.PlaceHolder FindAll():
  end method.

  /** opens a query for records matching the p_Where clause
   *  @param p_Where : the where statement to use  
   *  @return dotr.Maia.Model.PlaceHolder  
   */
  
  method public static dotr.Maia.Model.PlaceHolder FindWhere (p_BindingSource as BindingSource,p_Query as char):
  end method.

  /** clears all PlaceHolder with a foreign key
   *
   * @param p_fkGUID = Foreign Key
   */
  
  method public static void ClearDialPlan(p_fkGUID as char):
  end method.
  
  
  /** get all accounts associated with a foreign key
   *
   * @param p_fkGUID = Foreign Key
   */
  
    method public static dotr.Maia.Model.PlaceHolder GetDialPlan(p_fkGUID as char):
    end method.
  

end class.
