
/*
 Dot R Limited  CONFIDENTIAL
 Unpublished Copyright (c) 2011 Dot R Limited, All Rights Reserved.

 NOTICE:  All information contained herein is, and remains the property of Dot R Limited. The intellectual and technical concepts contained
 herein are proprietary to Dot R Limited and are protected by trade secret or copyright law.
 Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
 from Dot R Limited.  Access to the source code contained herein is hereby forbidden to anyone except current Dot R Limited employees, managers or contractors who have executed 
 Confidentiality and Non-disclosure agreements explicitly covering such access.

 The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
 information that is confidential and/or proprietary, and is a trade secret, of  Dot R Limited.   
 
 ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, OR PUBLIC DISPLAY OF OR THROUGH USE OF THIS SOURCE CODE 
 WITHOUT THE EXPRESS WRITTEN CONSENT OF Dot R Limited IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE LAWS AND INTERNATIONAL TREATIES.  
 THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
 TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.
*/


using Progress.Lang.*.

routine-level on error undo, throw.

class dotr.Maia.Model.Base.PlaceHolder:

  def public property rowid as rowid  get. set. /* must be undo, as any error on creation must be reset to ? */
  def public property Query as handle no-undo get . protected set .     
  
  def protected property buffer     as handle no-undo get . protected set .
  def protected property PrimaryKey as handle no-undo get . protected set .
  
  def public property PrivateData as char no-undo get. set.
  
  def public property Available as logical no-undo
    get():
    end get . protected set.
    
  def public property NumRecords as int no-undo
    get():
    end get . protected set.

  constructor PlaceHolder(p_PlaceHolderID as char):
  end constructor.

  constructor PlaceHolder():
  end constructor.


  /** Creates the buffer handle and buffer fields 
   */

  method protected void StartUp():
  end method.

  /** gets the PlaceHolder matching the unique ID 
   *  @param p_PlaceHolderID : the id to find
   */

  method public dotr.Maia.Model.PlaceHolder find(p_PlaceHolderID as char):
  end.

  /** stub method to allow for override
   */

  method public void AfterGet():
  end method.

 /** stub method to allow for override
   */

  method public void BeforeGet():
  end method.

 /** stub method to allow for override
  */

  method public void BeforeCreate():
  end method.
  
 /** stub method to allow for override
  */

  method public void AfterCreate():
  end method.

 /** stub method to allow for override
  */

  method public void BeforeUpdate():
  end method.
  
 /** stub method to allow for override
  */

  method public void AfterUpdate():
  end method.
  
 /** stub method to allow for override
  */

  method public void BeforeRemove():
  end method.
  
 /** stub method to allow for override
  */

  method public void AfterRemove():
  end method.

 /** stub method to allow for override
  */
  method public void NotFound():
  end method.

  /** assigns the buffer fields to the object
   *  @return dotr.Maia.Model.PlaceHolder  
   */

  method protected dotr.Maia.Model.PlaceHolder get():
  end.
  
  /** open a query for all records in the <<Table>> table
   */
  method public dotr.Maia.Model.PlaceHolder all():
  end method.

  /** opens a query for records matching the p_Where clause
   *  @param p_Where : the where statement to use  
   *  @return dotr.Maia.Model.PlaceHolder  
   */
  
  method public dotr.Maia.Model.PlaceHolder FindWhere (p_BindingSource as progress.Data.BindingSource,p_Where as char):
  end method.

  /** opens a query for records matching the p_Where clause
   *  @param p_Where : the where statement to use  
   *  @return dotr.Maia.Model.PlaceHolder  
   */
  
  method public dotr.Maia.Model.PlaceHolder FindWhere (p_Where as char):
  end method.

  /** opens a query for records matching the p_Where clause
   *  @param p_Where : the where statement to use  
   *  @return dotr.Maia.Model.PlaceHolder  
   */
  
  method public dotr.Maia.Model.PlaceHolder preselect (p_Where as char):
  end method.
  
  /** gets the first PlaceHolder of the query
   *  @return dotr.Maia.Model.PlaceHolder  
   */

  method public dotr.Maia.Model.PlaceHolder first():
  end method.
    
  /** gets the last PlaceHolder of the query
   *  @return dotr.Maia.Model.PlaceHolder  
   */

  method public dotr.Maia.Model.PlaceHolder last():
  end method.

  /** gets the next PlaceHolder of the query
   *  @return dotr.Maia.Model.PlaceHolder  
   */

  method public dotr.Maia.Model.PlaceHolder next():
  end method.

  /** gets the prev PlaceHolder of the query
   *  @return dotr.Maia.Model.PlaceHolder  
   */

  method public dotr.Maia.Model.PlaceHolder prev():
  end method.

  /** saves the object attributes to the database
   *  @return dotr.Maia.Model.PlaceHolder  
   */
  
  method public dotr.Maia.Model.PlaceHolder save():
  end method.

  /** removes the object from the database
   */
 
  method public void Remove():
  end method. 

  /** writes the approriate changes to the database
   *  @param p_Mode : create (creates a new <<table>>
   *                : update (saves the changes to the database)
   *                : remove (removes the record from the database)
   */
    
  method protected final void WriteRecord(p_Mode as char):
  end method.    

end class.
