/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


define input parameter p_Data as char no-undo.

{C:\Progress\OpenEdge\src\adecomm\oeideservice.i}

def var lv_Prog as longchar no-undo.

def var lv_xml    as char no-undo.
def var lv_Result as char no-undo.
def var lv_source as char no-undo.

def var lv_Start as int no-undo.
def var lv_i     as int no-undo.

def var lv_Build as logical no-undo.

def var Builder1      as dotr.Maia.Builder.ObjectBuilder no-undo.
def var ObjectConfig1 as dotr.Maia.Model.ObjectConfig    no-undo.

if entry(1,p_Data,chr(3)) eq "object" then
do:
  run dotr/Maia/ObjectConfigWindow.w.
  assign lv_build = no.
  return.
end.

assign file-info:file-name = entry(2,p_Data,chr(3)).

if file-info:full-pathname eq ? then
do:
  message substitute("Unable to find file &1",entry(2,p_Data,chr(3))) view-as alert-box warning.
  return.
end.

if file-info:full-pathname matches "*.xml" then assign lv_xml = replace(file-info:full-pathname,os-getenv("ECLIPSE_ROOT"),"").

else 
do:
  assign lv_Source = replace(replace(file-info:full-pathname,os-getenv("ECLIPSE_ROOT"),""),"\","/").
  copy-lob from file file-info:full-pathname to lv_Prog.

  assign lv_Result = "@BuildInfo(Source="
         lv_Start  = index(lv_Prog,lv_Result).
         
  if lv_Start eq 0 then return.
  
  assign lv_Start = lv_Start + length(lv_Result)
         lv_xml = substr(lv_Prog,lv_Start ,index(lv_prog,")",lv_Start) - lv_Start)
         lv_xml = trim(lv_xml,'")').
end.

ObjectConfig1 = dotr.Maia.Model.ObjectConfig:Get(lv_xml).

case entry(1,p_Data,chr(3)):
  when "property" then 
  do:
    run dotr/Maia/PropertyWindow.w (ObjectConfig1:ClassName).
    assign lv_build = yes.
  end.

  when "build" then assign lv_build = yes.
end case.

Builder1 = dotr.Maia.Builder.ObjectBuilder:Instance.

if lv_Build then Builder1:buildobject(ObjectConfig1).
    
finally: 
  if lv_Build and VALID-OBJECT(ObjectConfig1) then  
  do lv_i = 1 to ObjectConfig1:NumTemplates:
    if not valid-object(ObjectConfig1:Template[lv_i]) then next.
    process events.
    if lv_Source ne ObjectConfig1:Template[lv_i]:Outputfile then next.
    compile value(ObjectConfig1:Template[lv_i]:Outputfile) save no-error. 
    run sendRequest in hOEIDEService(substitute('IDE openEditor "&1" "&2" ""', 
                                                getProjectName(),
                                                ObjectConfig1:Template[lv_i]:Outputfile), 
                                     true, 
                                     output lv_Result). 
  end.
         
  delete object Builder1      no-error.
  delete object ObjectConfig1 no-error.
  
end finally.
