&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DECLARATIONS Dialog-Frame 

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*
Copyright (c) 2011, Julian Lyndon-Smith (julian+maia@dotr.com)
http://www.dotr.com
All rights reserved.

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction except as noted below, including without limitation
the rights to use,copy, modify, merge, publish, distribute,
and/or sublicense, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

 The Software and/or source code cannot be copied in whole and
 sold without meaningful modification for a profit.

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in
 the documentation and/or other materials provided with
 the distribution.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

&IF DEFINED(UIB_IS_RUNNING) eq 0 &THEN
def input parameter p_Property as dotr.Maia.Model.Property no-undo.
&ELSE
def var p_Property as dotr.Maia.Model.Property no-undo.
p_Property = new dotr.Maia.Model.Property().
&ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-7 RECT-33 RECT-34 fillin_Property ~
fillin_FieldName fillin_Fluent fillin_Label fillin_Brief editor_Comments ~
ComboDataType ComboSequence Combo_Access fillin_Extent Combo_Get Combo_Set ~
EDITOR-1 EDITOR-2 fillin_DisplayInLookup Combo_Width fillin_DisplayInForm ~
FILL-IN-UIName fillin_DisplayInGrid COMBO-BOX-UI toggle_isForeignKey ~
Combo_fkObject fillin_fkPropertyName fillin_fkModelName ~
toggle_GenerateModel Toggle_Update Toggle_Cascade ToggleOverride ~
Toggle_BuildField Toggle_GenerateGUID Button_Save Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS fillin_Property fillin_FieldName ~
fillin_Fluent fillin_Label fillin_Brief editor_Comments ComboDataType ~
ComboSequence Combo_Access fillin_Extent Combo_Get Combo_Set EDITOR-1 ~
EDITOR-2 fillin_DisplayInLookup Combo_Width fillin_DisplayInForm ~
FILL-IN-UIName fillin_DisplayInGrid COMBO-BOX-UI toggle_isForeignKey ~
Combo_fkObject fillin_fkPropertyName fillin_fkModelName ~
toggle_GenerateModel Toggle_Update Toggle_Cascade Toggle_GetAll ~
ToggleOverride Toggle_BuildField Toggle_GenerateGUID 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */
&Scoped-define List-3 fillin_Property fillin_Fluent fillin_Label ~
fillin_DisplayInLookup fillin_DisplayInForm fillin_DisplayInGrid 

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD StartUp Dialog-Frame 
function StartUp returns logical () forward.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD VerifyData Dialog-Frame 
function VerifyData returns logical
  ( )  forward.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
define button Btn_Cancel auto-end-key 
     label "Cancel" 
     context-help-id 2415
     size 15 by 1.14 tooltip "ContextDone"
     bgcolor 8 .

define button Button_Save auto-go 
     label "&Save" 
     context-help-id 2414
     size 15 by 1.14 tooltip "&Save"
     bgcolor 8 .

define variable COMBO-BOX-UI as character initial "Text Box" 
     label "UI Type" 
     view-as combo-box sort inner-lines 10
     list-item-pairs "Text Box","TextEdit",
                     "Editor","MemoEdit",
                     "Combo Box","ComboBox",
                     "Selection List","SelectionList",
                     "Check Box","CheckBox",
                     "Radio Set","RadioSet",
                     "Date Picker","DateEdit"
     drop-down
     size 40 by 1 no-undo.

define variable ComboDataType as character initial "Character" 
     label "Data Type" 
     view-as combo-box inner-lines 20
     list-items "Character","Integer","INT64","Logical","Decimal","Date","DateTime","DateTime-TZ","Rowid","Recid" 
     drop-down
     size 40 by 1 no-undo.

define variable ComboSequence as character format "X(256)":U 
     label "&Sequence" 
     view-as combo-box inner-lines 25
     list-items "-- Not Used --" 
     drop-down-list
     size 40 by 1 no-undo.

define variable Combo_Access as character format "X(256)":U initial "Public" 
     label "Access Mode" 
     view-as combo-box sort inner-lines 10
     list-items "Private","Protected","Public","Static","Abstract" 
     drop-down-list
     size 40 by 1 no-undo.

define variable Combo_fkObject as character format "X(256)":U 
     label "Foreign Object Name" 
     view-as combo-box sort inner-lines 25
     drop-down-list
     size 36 by 1 no-undo.

define variable Combo_Get as character format "X(256)":U initial "Public" 
     label "&GET" 
     view-as combo-box inner-lines 25
     list-items "-- Not Used --","Private","Public" 
     drop-down-list
     size 40 by 1 no-undo.

define variable Combo_Set as character format "X(256)":U initial "Public" 
     label "&SET" 
     view-as combo-box inner-lines 25
     list-items "-- Not Used --","Private","Public" 
     drop-down-list
     size 40 by 1 no-undo.

define variable Combo_Width as integer format ">9":U initial 0 
     label "Width Scale" 
     view-as combo-box inner-lines 25
     list-items "1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20" 
     drop-down-list
     size 16 by 1 no-undo.

define variable EDITOR-1 as character 
     view-as editor no-word-wrap scrollbar-vertical
     size 40 by 3.1 tooltip "Enter the get code" no-undo.

define variable EDITOR-2 as character 
     view-as editor no-word-wrap scrollbar-vertical
     size 40 by 3.1 tooltip "Enter the SET code" no-undo.

define variable editor_Comments as character 
     view-as editor scrollbar-vertical
     size 93 by 4.52 no-undo.

define variable FILL-IN-UIName as character format "X(256)":U 
     label "UI Name" 
     view-as fill-in 
     size 40 by 1 no-undo.

define variable fillin_Brief as character format "X(256)":U 
     label "&Brief Description" 
     view-as fill-in 
     size 93 by 1 no-undo.

define variable fillin_DisplayInForm as integer format ">9" initial 0 
     label "Form display Position" 
     context-help-id 2413
     view-as fill-in native 
     size 6 by 1.

define variable fillin_DisplayInGrid as integer format ">9" initial 0 
     label "Grid Position" 
     context-help-id 2413
     view-as fill-in native 
     size 6 by 1.

define variable fillin_DisplayInLookup as integer format ">9" initial 0 
     label "Lookup Position" 
     context-help-id 2413
     view-as fill-in native 
     size 6 by 1.

define variable fillin_Extent as integer format ">>9":U initial 0 
     label "E&xtent" 
     view-as fill-in 
     size 10 by 1 no-undo.

define variable fillin_FieldName as character format "x(32)" 
     label "Field Name" 
     view-as fill-in 
     size 40 by 1.

define variable fillin_fkModelName as character format "X(256)":U 
     label "Model" 
     view-as fill-in 
     size 36 by 1 no-undo.

define variable fillin_fkPropertyName as character format "X(256)":U 
     label "Property Name" 
     view-as fill-in 
     size 36 by 1 no-undo.

define variable fillin_Fluent as character format "x(120)" 
     label "&Fluent Name" 
     context-help-id 2413
     view-as fill-in native 
     size 40 by 1.

define variable fillin_Label as character format "x(120)" 
     label "&Label" 
     context-help-id 2413
     view-as fill-in native 
     size 40 by 1.

define variable fillin_Property as character format "x(120)" 
     label "&Property Name" 
     context-help-id 2413
     view-as fill-in native 
     size 40 by 1.

define rectangle RECT-33
     edge-pixels 2 graphic-edge  no-fill   
     size 108 by 4.29.

define rectangle RECT-34
     edge-pixels 2 graphic-edge  no-fill   
     size 108 by 4.48.

define rectangle RECT-7
     edge-pixels 2 graphic-edge  no-fill   
     size 113 by 26.91.

define variable ToggleOverride as logical initial no 
     label "O&verride" 
     view-as toggle-box
     size 13.4 by 1 no-undo.

define variable Toggle_BuildField as logical initial no 
     label "Include Property when building" 
     view-as toggle-box
     size 34 by 1 no-undo.

define variable Toggle_Cascade as logical initial no 
     label "Cascade Delete" 
     view-as toggle-box
     size 21 by .81 no-undo.

define variable Toggle_GenerateGUID as logical initial no 
     label "Generate GUID" 
     view-as toggle-box
     size 22 by 1 no-undo.

define variable toggle_GenerateModel as logical initial no 
     label "Load fk Object" 
     view-as toggle-box
     size 19 by .81 no-undo.

define variable Toggle_GetAll as logical initial no 
     label "Get All" 
     view-as toggle-box
     size 11 by .81 no-undo.

define variable toggle_isForeignKey as logical initial no 
     label "Foreign Key" 
     view-as toggle-box
     size 16 by .81 no-undo.

define variable Toggle_Update as logical initial no 
     label "Cascade Clear" 
     view-as toggle-box
     size 19 by .81 no-undo.


/* ************************  Frame Definitions  *********************** */

define frame Dialog-Frame
     fillin_Property at row 1.71 col 18 colon-aligned
     fillin_FieldName at row 1.71 col 71 colon-aligned
     fillin_Fluent at row 2.91 col 18 colon-aligned widget-id 40
     fillin_Label at row 2.91 col 71 colon-aligned widget-id 58
     fillin_Brief at row 4.1 col 18 colon-aligned widget-id 66
     editor_Comments at row 5.29 col 20 no-label widget-id 70
     ComboDataType at row 10.05 col 18 colon-aligned widget-id 14
     ComboSequence at row 10.05 col 71 colon-aligned widget-id 16
     Combo_Access at row 11.24 col 18 colon-aligned widget-id 24
     fillin_Extent at row 11.24 col 71 colon-aligned widget-id 28
     Combo_Get at row 12.43 col 18 colon-aligned widget-id 30
     Combo_Set at row 12.43 col 71 colon-aligned widget-id 32
     EDITOR-1 at row 13.62 col 20 no-label widget-id 34
     EDITOR-2 at row 13.62 col 73 no-label widget-id 36
     fillin_DisplayInLookup at row 17.91 col 26 colon-aligned widget-id 48
     Combo_Width at row 17.91 col 48 colon-aligned widget-id 64
     fillin_DisplayInForm at row 19.1 col 26 colon-aligned widget-id 50
     FILL-IN-UIName at row 19.1 col 48 colon-aligned widget-id 42
     fillin_DisplayInGrid at row 20.29 col 26 colon-aligned widget-id 52
     COMBO-BOX-UI at row 20.29 col 48 colon-aligned widget-id 44
     toggle_isForeignKey at row 21.91 col 7 widget-id 88
     Combo_fkObject at row 22.91 col 28 colon-aligned widget-id 90
     fillin_fkPropertyName at row 24.1 col 28 colon-aligned widget-id 102
     fillin_fkModelName at row 24.1 col 73 colon-aligned widget-id 104
     toggle_GenerateModel at row 25.52 col 8 widget-id 96
     Toggle_Update at row 25.52 col 27 widget-id 98
     Toggle_Cascade at row 25.52 col 46 widget-id 94
     Toggle_GetAll at row 25.52 col 100 widget-id 100
     ToggleOverride at row 26.95 col 5 widget-id 26
     Toggle_BuildField at row 26.95 col 21 widget-id 2
     Toggle_GenerateGUID at row 26.95 col 57 widget-id 4
     Button_Save at row 28.38 col 84 help
          "ContextDone"
     Btn_Cancel at row 28.38 col 100 help
          "ContextDone"
     " Display Options" view-as text
          size 17.6 by .62 at row 17.14 col 6.4 widget-id 56
     RECT-7 at row 1.24 col 2
     RECT-33 at row 17.43 col 5 widget-id 54
     RECT-34 at row 22.24 col 5 widget-id 84
     space(3.19) skip(3.27)
    with view-as dialog-box keep-tab-order 
         side-labels no-underline three-d  scrollable 
         title "Property Maintenance"
         default-button Button_Save cancel-button Btn_Cancel
         context-help.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
   FRAME-NAME                                                           */
assign 
       frame Dialog-Frame:SCROLLABLE       = false.

assign 
       EDITOR-1:RETURN-INSERTED in frame Dialog-Frame  = true.

assign 
       EDITOR-2:RETURN-INSERTED in frame Dialog-Frame  = true.

assign 
       editor_Comments:RETURN-INSERTED in frame Dialog-Frame  = true.

/* SETTINGS FOR FILL-IN fillin_DisplayInForm IN FRAME Dialog-Frame
   3                                                                    */
/* SETTINGS FOR FILL-IN fillin_DisplayInGrid IN FRAME Dialog-Frame
   3                                                                    */
/* SETTINGS FOR FILL-IN fillin_DisplayInLookup IN FRAME Dialog-Frame
   3                                                                    */
assign 
       fillin_FieldName:READ-ONLY in frame Dialog-Frame        = true.

/* SETTINGS FOR FILL-IN fillin_Fluent IN FRAME Dialog-Frame
   3                                                                    */
/* SETTINGS FOR FILL-IN fillin_Label IN FRAME Dialog-Frame
   3                                                                    */
/* SETTINGS FOR FILL-IN fillin_Property IN FRAME Dialog-Frame
   3                                                                    */
/* SETTINGS FOR TOGGLE-BOX Toggle_GetAll IN FRAME Dialog-Frame
   NO-ENABLE                                                            */
/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX Dialog-Frame
/* Query rebuild information for DIALOG-BOX Dialog-Frame
     _Options          = "no-lock indexED-REPOSITION KEEP-EMPTY"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX Dialog-Frame */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
on go of frame Dialog-Frame /* Property Maintenance */
do:
 assign p_Property:BuildProperty    = Toggle_BuildField:checked          
        p_Property:GenerateGUID     = Toggle_GenerateGUID:checked
        p_Property:PropertyName     = fillin_Property:screen-value
        p_Property:DataType         = ComboDataType:screen-value
        p_Property:Sequence         = ComboSequence:screen-value
        p_Property:Override         = ToggleOverride:checked
        p_Property:extent           = int(fillin_Extent:screen-value)    
        p_Property:AccessMode       = Combo_Access:screen-value             
        p_Property:GetMode          = Combo_Get:screen-value                
        p_Property:SetMode          = Combo_Set:screen-value
        p_Property:Comment          = Editor_Comments:screen-value      
        p_Property:Brief            = fillin_Brief:screen-value      
        p_Property:GetCode          = EDITOR-1:screen-value
        p_Property:Fluent           = fillin_Fluent:screen-value
        p_Property:UIName           = FILL-IN-UIName:screen-value
        p_Property:UIType           = COMBO-BOX-UI:screen-value                   
        p_Property:FormLabel        = fillin_Label:screen-value                   
        p_Property:DisplayInLookup  = fillin_DisplayInLookup:input-value                   
        p_Property:DisplayInGrid    = fillin_DisplayInGrid:input-value                   
        p_Property:DisplayInForm    = fillin_DisplayInForm:input-value                   
        p_Property:WidthScale       = Combo_Width:input-value                   
        p_Property:SetCode          = EDITOR-2:screen-value
        p_Property:fkClassName      = if toggle_isForeignKey:checked then Combo_fkObject:screen-value else ""
        p_Property:fkModelName      = if fillin_fkModelName:screen-value eq "" then Combo_fkObject:screen-value else fillin_fkModelName:screen-value 
        p_Property:fkPropertyName   = if toggle_isForeignKey:checked then fillin_fkPropertyName:screen-value else "" 
        p_Property:isForeignKey     = toggle_isForeignKey:checked     
        p_Property:fkDelete         = Toggle_Cascade:Checked         
        p_Property:fkUpdate         = Toggle_Update:Checked         
        p_Property:fkGetAll         = Toggle_GetAll:Checked         
        p_Property:LoadfkProperty = toggle_GenerateModel:checked.
        
 if p_Property:FieldName eq "" then assign p_Property:FieldName = p_Property:PropertyName.
 
 if p_Property:ManualProperty then assign p_Property:FieldName = fillin_FieldName:screen-value.
 if not VerifyData() then return no-apply.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
on window-close of frame Dialog-Frame /* Property Maintenance */
do:
  apply "END-ERROR":U to self.
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME ComboDataType
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ComboDataType Dialog-Frame
on value-changed of ComboDataType in frame Dialog-Frame /* Data Type */
do:
 case self:screen-value:
    when "INTEGER" or when "INT64" then assign ComboSequence:SENSITIVE     = yes
                                               Toggle_GenerateGUID:checked   = no
                                               Toggle_GenerateGUID:SENSITIVE = no.
    
    when "CHARACTER" then assign Toggle_GenerateGUID:SENSITIVE = yes
                                 ComboSequence:SENSITIVE     = no
                                 ComboSequence:screen-value  = "-- Not Used --".

    otherwise assign Toggle_GenerateGUID:checked   = no
                     Toggle_GenerateGUID:SENSITIVE = no
                     ComboSequence:SENSITIVE     = no
                     ComboSequence:screen-value  = "-- Not Used --".
  end case.
    
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME fillin_Property
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL fillin_Property Dialog-Frame
on leave of fillin_Property in frame Dialog-Frame /* Property Name */
do:
  if fillin_FieldName:screen-value eq "" then assign fillin_FieldName:screen-value = self:screen-value.   
  if fillin_Fluent:screen-value    eq "" then assign fillin_Fluent:screen-value    = self:screen-value.   
  if fillin_Label:screen-value     eq "" then assign fillin_Label:screen-value     = self:screen-value.   
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
if valid-handle(active-window) and frame {&FRAME-NAME}:PARENT eq ?
then frame {&FRAME-NAME}:PARENT = active-window.

if p_Property:FieldName eq "" then assign frame {&FRAME-NAME}:TITLE = "Create New Property"
                                          p_Property:ManualProperty = yes.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
do on error   undo MAIN-BLOCK, leave MAIN-BLOCK
   on end-key undo MAIN-BLOCK, leave MAIN-BLOCK:
  
  Startup().
  
  run enable_UI.
  
  apply "VALUE-CHANGED" to ComboDataType.
  
  if not p_Property:ManualProperty then assign ComboDataType:SENSITIVE = no.
  
  wait-for go of frame {&FRAME-NAME}.
end.
run disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
procedure disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  hide frame Dialog-Frame.
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
procedure enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  display fillin_Property fillin_FieldName fillin_Fluent fillin_Label 
          fillin_Brief editor_Comments ComboDataType ComboSequence Combo_Access 
          fillin_Extent Combo_Get Combo_Set EDITOR-1 EDITOR-2 
          fillin_DisplayInLookup Combo_Width fillin_DisplayInForm FILL-IN-UIName 
          fillin_DisplayInGrid COMBO-BOX-UI toggle_isForeignKey Combo_fkObject 
          fillin_fkPropertyName fillin_fkModelName toggle_GenerateModel 
          Toggle_Update Toggle_Cascade Toggle_GetAll ToggleOverride 
          Toggle_BuildField Toggle_GenerateGUID 
      with frame Dialog-Frame.
  enable RECT-7 RECT-33 RECT-34 fillin_Property fillin_FieldName fillin_Fluent 
         fillin_Label fillin_Brief editor_Comments ComboDataType ComboSequence 
         Combo_Access fillin_Extent Combo_Get Combo_Set EDITOR-1 EDITOR-2 
         fillin_DisplayInLookup Combo_Width fillin_DisplayInForm FILL-IN-UIName 
         fillin_DisplayInGrid COMBO-BOX-UI toggle_isForeignKey Combo_fkObject 
         fillin_fkPropertyName fillin_fkModelName toggle_GenerateModel 
         Toggle_Update Toggle_Cascade ToggleOverride Toggle_BuildField 
         Toggle_GenerateGUID Button_Save Btn_Cancel 
      with frame Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
end procedure.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION StartUp Dialog-Frame 
function StartUp returns logical ():
  def var lv_ConfigFile as char no-undo.
  
  def var lv_i     as int no-undo.
  
  assign file-info:file-name = dotr.Maia.CurrentProject:ConfigDirectory.
         
  if file-info:full-pathname eq ? then return no.
           
  input from OS-DIR (file-info:full-pathname) NO-ATTR-LIST .
  
  Combo_fkObject:add-last("") in frame {&frame-name}.
  
  repeat lv_i = 1 to lv_i + 1 on error undo, throw:
    import delimiter " " lv_ConfigFile .

    if search(substitute("&1/&2/_Config.xml",dotr.Maia.CurrentProject:ConfigDirectory,lv_ConfigFile)) eq ? then next.

    Combo_fkObject:add-last(lv_ConfigFile) in frame {&frame-name}.
  end.

  input CLOSE.
  
  assign Combo_fkObject = lv_ConfigFile.
 
 for each DICTDB._SEQ no-lock with frame {&FRAME-NAME}:
   ComboSequence:ADD-LAST(DICTDB._Seq._Seq-name).
 end.
      
 assign Toggle_BuildField      = p_Property:BuildProperty          
        fillin_FieldName       = p_Property:FieldName          
        ToggleOverride         = p_Property:GenerateGUID
        Toggle_GenerateGUID    = p_Property:GenerateGUID
        ComboDataType          = if p_Property:DataType eq "" then "character" else p_Property:DataType      
        fillin_Property        = p_Property:PropertyName      
        Combo_Access           = p_Property:AccessMode      
        Combo_Get              = p_Property:GetMode      
        Combo_Set              = p_Property:SetMode      
        EDITOR-1               = p_Property:GetCode      
        EDITOR-2               = p_Property:SetCode      
        Editor_Comments        = p_Property:Comment
        fillin_Brief           = p_Property:Brief
        fillin_Extent          = p_Property:extent
        fillin_fluent          = p_Property:Fluent
        FILL-IN-UIName         = p_Property:UIName
        fillin_Label           = p_Property:FormLabel
        COMBO-BOX-UI           = p_Property:UIType
        Combo_Width            = p_Property:WidthScale    
        fillin_DisplayInLookup = p_Property:DisplayInLookup
        fillin_DisplayInForm   = p_Property:DisplayInForm
        fillin_DisplayInGrid   = p_Property:DisplayInGrid
        ComboSequence          = p_Property:Sequence
        Combo_fkObject         = p_Property:fkClassName
        fillin_fkModelName     = p_Property:fkModelName
        fillin_fkPropertyName  = if p_Property:fkPropertyName eq "" then p_Property:fkClassName else p_Property:fkPropertyName 
        toggle_isForeignKey    = p_Property:isForeignKey
        Toggle_Cascade         = p_Property:fkDelete
        Toggle_Update          = p_Property:fkUpdate
        Toggle_GetAll          = p_Property:fkGetAll
        toggle_GenerateModel   = p_Property:LoadfkProperty.
        
  if p_Property:ManualProperty then assign fillin_FieldName:read-only = no.         
end function.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION VerifyData Dialog-Frame 
function VerifyData returns logical
  ( ) :
  do on error undo, leave:

  end.
  
  return yes.
  
end function.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

