/*
 Dot R Limited  CONFIDENTIAL
 Unpublished Copyright (c) 2011 Dot R Limited, All Rights Reserved.

 NOTICE:  All information contained herein is, and remains the property of Dot R Limited. The intellectual and technical concepts contained
 herein are proprietary to Dot R Limited and are protected by trade secret or copyright law.
 Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
 from Dot R Limited.  Access to the source code contained herein is hereby forbidden to anyone except current Dot R Limited employees, managers or contractors who have executed 
 Confidentiality and Non-disclosure agreements explicitly covering such access.

 The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
 information that is confidential and/or proprietary, and is a trade secret, of  Dot R Limited.   
 
 ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, OR PUBLIC DISPLAY OF OR THROUGH USE OF THIS SOURCE CODE 
 WITHOUT THE EXPRESS WRITTEN CONSENT OF Dot R Limited IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE LAWS AND INTERNATIONAL TREATIES.  
 THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
 TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.
*/
using Progress.Lang.*.
using dotr.Maia.Stomp.Helper.*.
using dotr.Maia.Stomp.*.
using dotr.Maia.Stomp.Interface.*.
using sports.Config.Asterisk.*.

routine-level on error undo, throw.

class dotr.Maia.Stomp.Helper.Client implements IStompHandler: 

  def var lv_Data as longchar no-undo.
  
  def var StompServer   as StompServer   no-undo.
  def var StompConsumer as StompConsumer no-undo.
  def var StompProducer as StompProducer no-undo.

  def public event NewMessage signature void (p_Message as IStompMessage).
    
  constructor Client(p_Server as char):
    init(p_Server).
  end constructor.
        
  destructor Client():
    delete object StompConsumer.
    delete object StompProducer.
    delete object StompServer.
  end destructor.
  
  method private void init(p_Server as char):
    
    StompServer = new StompServer(p_Server).
    
    StompConsumer = new StompConsumer(StompServer,this-object).
    StompProducer = new StompProducer(StompServer).
  
  end method.

  method private void Quit():
    delete object this-object.
  end method.
  
  method public void SubscribeToQueue(p_Destination as char):
    StompConsumer:SubscribeToQueue(p_Destination).
  end method.

  method public void SubscribeToTopic(p_Destination as char):
    StompConsumer:SubscribeToTopic(p_Destination).
  end method.

  method public void UnSubscribeFromQueue(p_Destination as char):
    StompConsumer:UnSubscribeFromQueue(p_Destination).
  end method.

  method public void UnSubscribeFromTopic(p_Destination as char):
    StompConsumer:UnSubscribeFromTopic(p_Destination).
  end method.
  

  method public void SendMessageToTopic(p_Topic as char,p_Message as longchar):
    StompProducer:SendTopic(p_Topic,p_Message).
  end method.

  method public void SendMessageToQueue(p_Queue as char,p_Message as longchar):
    StompProducer:SendQueue(p_Queue,p_Message).
  end method.

  method public void NewStompMessage(p_Message as IStompMessage):

    NewMessage:Publish(p_Message).    
    catch e as Progress.Lang.Error :
      message e:GetMessage(1) skip(1) e:CallStack view-as alert-box.
    end catch.    
  end method.

end class.