 
 /*------------------------------------------------------------------------
    File        : StompQueue
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : Julian
    Created     : Mon Aug 08 17:42:15 BST 2011
    Notes       : 
  ----------------------------------------------------------------------*/

using Progress.Lang.*.
using dotr.Maia.Stomp.*.
using dotr.Maia.Stomp.Interface.*.

routine-level on error undo, throw.

class dotr.Maia.Stomp.StompProducer implements IStompProducer :

  def var StompConnection as dotr.Maia.Stomp.StompConnection no-undo.
  
  constructor StompProducer(p_StompServer as StompServer):
    StompConnection = new dotr.Maia.Stomp.StompConnection(p_StompServer).
  end constructor.

  destructor StompProducer():
  end destructor.
    
  method public void SendQueue(p_Dest as char,p_Message as longchar):
    SendQueue(p_Dest,p_Message,?).
  end method.

  method public void SendQueue(p_Dest as char,p_Message as longchar,p_Expires as datetime):
    Send(substitute("/queue/&1",p_Dest),p_message,p_expires).
  end method.

  method public void SendTopic(p_Dest as char,p_Message as longchar):
    SendTopic(p_Dest,p_Message,?).
  end method.

  method public void SendTopic(p_Dest as char,p_Message as longchar,p_Expires as datetime):
    Send(substitute("/topic/&1",p_Dest),p_message,p_expires).
  end method.

  method private void Send(p_Dest as char,p_Message as longchar,p_Expires as datetime):
    def var lv_Expires as int64 no-undo.
    
    def var lv_header as char no-undo.
    
    assign lv_expires = p_Expires - DATETIME(1, 1, 1970, 0, 0, 0, 0)
           lv_Header  = substitute("SEND~ndestination: &1~ncontent-type:text/plain~n&2persistent:false~n~n",
                                   p_Dest,
                                   if p_expires eq ? then "" else substitute("expires: &1~n",lv_expires)).

    StompConnection:sendFrame(lv_Header + p_message).
  end method.
    

end class.