
/*
Copyright (C) 2011 by Julian Lyndon-Smith (julian+mit@dotr.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS for A PARTICULAR PURPOSE and NONINFRINGEMENT. IN no EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE for ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR otherwise, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* $Id$ */

using Progress.Lang.*.
using Progress.Windows.Form.
using dotr.Maia.*.

routine-level on error undo, throw.

class sports.UI.winform.Update.Base.CustomerBaseUpdate inherits dotr.Maia.UI.winform.dotrForm: 
	
	define private variable components as System.ComponentModel.IContainer no-undo.

  def protected var Customer1 as sports.Model.Customer no-undo.
  
  define protected variable groupControl1 as DevExpress.XtraEditors.GroupControl no-undo.
  define protected variable simpleButton2 as DevExpress.XtraEditors.SimpleButton no-undo.
  define protected variable simpleButton1 as DevExpress.XtraEditors.SimpleButton no-undo.
  def protected var uiName as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelName as DevExpress.XtraEditors.LabelControl no-undo.
  def protected var uiCustNum as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelCustNum as DevExpress.XtraEditors.LabelControl no-undo.
  
  define protected variable Update_Fill_Panel as System.Windows.Forms.Panel no-undo.
  
	constructor public CustomerBaseUpdate (p_Customer as sports.Model.Customer  ):
	  super().
    InitializeComponent().
    assign Customer1 = p_Customer.
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

	end constructor.

  constructor public CustomerBaseUpdate ():
    super().
    InitializeComponent().
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

  end constructor.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void BaseUpdate_FormClosed( input sender as System.Object, input e as System.Windows.Forms.FormClosedEventArgs ):
		shutdown().
		return.

	end method.

	method private void InitializeComponent(  ):
		THIS-OBJECT:uiName = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelName = NEW DevExpress.XtraEditors.LabelControl().
  THIS-OBJECT:uiCustNum = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelCustNum = NEW DevExpress.XtraEditors.LabelControl().
		 
    /* NOTE: The following method is automatically generated.
    
    We strongly suggest that the contents of this method only be modified using the
    Visual Designer to avoid any incompatible modifications.
    
    Modifying the contents of this method using a code editor will invalidate any support for this file. */
    this-object:Update_Fill_Panel = new System.Windows.Forms.Panel().
    this-object:simpleButton2 = new DevExpress.XtraEditors.SimpleButton().
    this-object:simpleButton1 = new DevExpress.XtraEditors.SimpleButton().
    this-object:groupControl1 = new DevExpress.XtraEditors.GroupControl().
    this-object:Update_Fill_Panel:SuspendLayout().
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):BeginInit().
    this-object:SuspendLayout().
    /*  */
    /* Update_Fill_Panel */
    /*  */
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton2).
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton1).
    this-object:Update_Fill_Panel:Controls:Add(this-object:groupControl1).
    this-object:Update_Fill_Panel:Cursor = System.Windows.Forms.Cursors:Default.
    this-object:Update_Fill_Panel:Dock = System.Windows.Forms.DockStyle:Fill.
    this-object:Update_Fill_Panel:Location = new System.Drawing.Point(0, 0).
    this-object:Update_Fill_Panel:Name = "Update_Fill_Panel".
    this-object:Update_Fill_Panel:Size = new System.Drawing.Size(665, 461).
    this-object:Update_Fill_Panel:TabIndex = 0.
    /*  */
    /* simpleButton2 */
    /*  */
    this-object:simpleButton2:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    this-object:simpleButton2:Location = new System.Drawing.Point(578, 426).
    this-object:simpleButton2:Name = "simpleButton2".
    this-object:simpleButton2:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton2:TabIndex = 21.
    this-object:simpleButton2:Text = "C&ancel".
    this-object:simpleButton2:Click:Subscribe(this-object:simpleButton2_Click).
    /*  */
    /* simpleButton1 */
    /*  */
    this-object:simpleButton1:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:simpleButton1:Location = new System.Drawing.Point(497, 426).
    this-object:simpleButton1:Name = "simpleButton1".
    this-object:simpleButton1:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton1:TabIndex = 20.
    this-object:simpleButton1:Text = "&Save".
    this-object:simpleButton1:Click:Subscribe(this-object:simpleButton1_Click).
    /*  */
    /* groupControl1 */
    /*  */
    this-object:groupControl1:Location = new System.Drawing.Point(12, 12).
    this-object:groupControl1:Name = "groupControl1".
    this-object:groupControl1:ShowCaption = false.
    this-object:groupControl1:Size = new System.Drawing.Size(643, 399).
    this-object:groupControl1:TabIndex = 8.
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiName).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelName).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiCustNum).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelCustNum).
THIS-OBJECT:groupControl1:Text = "groupControl1".
CAST(THIS-OBJECT:uiName:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
CAST(THIS-OBJECT:uiCustNum:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
/*  */
/* uiCustNum */
/*  */
THIS-OBJECT:uiCustNum:Location = NEW System.Drawing.Point(60, 9).
THIS-OBJECT:uiCustNum:Name = "CustNum".
THIS-OBJECT:uiCustNum:Size = NEW System.Drawing.Size(100, 20).
THIS-OBJECT:uiCustNum:TabIndex = 3.
/*  */
/* labelCustNum */
/*  */
THIS-OBJECT:labelCustNum:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelCustNum:Location = NEW System.Drawing.Point(10, 10).
THIS-OBJECT:labelCustNum:Name = "labelCustNum".
THIS-OBJECT:labelCustNum:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelCustNum:TabIndex = 2.
THIS-OBJECT:labelCustNum:Text = "CustNum:".
/*  */
/* uiName */
/*  */
THIS-OBJECT:uiName:Location = NEW System.Drawing.Point(60, 35).
THIS-OBJECT:uiName:Name = "Name".
THIS-OBJECT:uiName:Size = NEW System.Drawing.Size(200, 20).
THIS-OBJECT:uiName:TabIndex = 5.
/*  */
/* labelName */
/*  */
THIS-OBJECT:labelName:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelName:Location = NEW System.Drawing.Point(26, 36).
THIS-OBJECT:labelName:Name = "labelName".
THIS-OBJECT:labelName:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelName:TabIndex = 4.
THIS-OBJECT:labelName:Text = "Name:".

    /*  */
    /* CustomerBaseUpdate */
    /*  */
    this-object:CancelButton = this-object:simpleButton2.
    this-object:ClientSize = new System.Drawing.Size(665, 461).
    this-object:Controls:Add(this-object:Update_Fill_Panel).
    this-object:FormBorderStyle = System.Windows.Forms.FormBorderStyle:FixedDialog.
    this-object:LookAndFeel:SkinName = "Office 2010 Blue".
    this-object:LookAndFeel:UseDefaultLookAndFeel = false.
    this-object:Name = "BaseUpdate".
    this-object:SizeGripStyle = System.Windows.Forms.SizeGripStyle:Hide.
    
    this-object:Load:Subscribe(this-object:CustomerUpdate_Load).
    this-object:FormClosed:Subscribe(this-object:BaseUpdate_FormClosed).
    this-object:Update_Fill_Panel:ResumeLayout(false).
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiName:Properties, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiCustNum:Properties, System.ComponentModel.ISupportInitialize):EndInit().
THIS-OBJECT:ResumeLayout(FALSE).
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.
	end method.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void CustomerUpdate_Load( input sender as System.Object, input e as System.EventArgs ):

	  if not valid-object(Customer1) then return.
    
    assign uiName:text    = Customer1:Name
           uiCustNum:text = string(Customer1:CustNum).
    
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method protected void simpleButton1_Click( input sender as System.Object, input e as System.EventArgs ):
	  this-object:Save().
  end method.
  
  method protected void Save():		
           
    assign Customer1:Name    = uiName:Text
           Customer1:CustNum = Integer(uiCustNum:Text).
    
    do transaction on error undo, leave:
		  Customer1:Save().

      catch f as Progress.Lang.AppError:
        case f:GetMessageNum(1):
          otherwise message substitute ("Cannot save Customer [&1]",f:GetMessage(1)) view-as alert-box warning.
        end case.
       
        return .   
      end catch.
    end.
		
		this-object:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:Close ( ).
    
		return.

	end method.


  method private void shutdown():
    this-object:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    delete object this-object.
    return.
  end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void simpleButton2_Click( input sender as System.Object, input e as System.EventArgs ):
    this-object:Close().
		return.

	end method.
    
  destructor public CustomerBaseUpdate ( ):

		if valid-object(components) then do:
			cast(components, System.IDisposable):Dispose().
		end.

	end destructor.

end class.
@BuildInfo(Source="./sports/_Maia-Config/Customer/_Config.xml").
@BuildInfo(Date="30/08/2011 08:37:15.137+01:00").