
/*
Copyright (C) 2011 by Julian Lyndon-Smith (julian+mit@dotr.com)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS for A PARTICULAR PURPOSE and NONINFRINGEMENT. IN no EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE for ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR otherwise, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

/* $Id$ */

using Progress.Lang.*.
using Progress.Windows.Form.
using dotr.Maia.*.

routine-level on error undo, throw.

class sports.UI.winform.Update.Base.StateBaseUpdate inherits dotr.Maia.UI.winform.dotrForm: 
	
	define private variable components as System.ComponentModel.IContainer no-undo.

  def protected var State1 as sports.Model.State no-undo.
  
  define protected variable groupControl1 as DevExpress.XtraEditors.GroupControl no-undo.
  define protected variable simpleButton2 as DevExpress.XtraEditors.SimpleButton no-undo.
  define protected variable simpleButton1 as DevExpress.XtraEditors.SimpleButton no-undo.
  def protected var uiRegion as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelRegion as DevExpress.XtraEditors.LabelControl no-undo.
  def protected var uiState as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelState as DevExpress.XtraEditors.LabelControl no-undo.
  def protected var uiStateName as DevExpress.XtraEditors.TextEdit no-undo.
  def protected var labelStateName as DevExpress.XtraEditors.LabelControl no-undo.
  
  define protected variable Update_Fill_Panel as System.Windows.Forms.Panel no-undo.
  
	constructor public StateBaseUpdate (p_State as sports.Model.State  ):
	  super().
    InitializeComponent().
    assign State1 = p_State.
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

	end constructor.

  constructor public StateBaseUpdate ():
    super().
    InitializeComponent().
    
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.

  end constructor.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void BaseUpdate_FormClosed( input sender as System.Object, input e as System.Windows.Forms.FormClosedEventArgs ):
		shutdown().
		return.

	end method.

	method private void InitializeComponent(  ):
		THIS-OBJECT:uiRegion = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelRegion = NEW DevExpress.XtraEditors.LabelControl().
  THIS-OBJECT:uiState = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelState = NEW DevExpress.XtraEditors.LabelControl().
  THIS-OBJECT:uiStateName = NEW DevExpress.XtraEditors.TextEdit().
  THIS-OBJECT:labelStateName = NEW DevExpress.XtraEditors.LabelControl().
		 
    /* NOTE: The following method is automatically generated.
    
    We strongly suggest that the contents of this method only be modified using the
    Visual Designer to avoid any incompatible modifications.
    
    Modifying the contents of this method using a code editor will invalidate any support for this file. */
    this-object:Update_Fill_Panel = new System.Windows.Forms.Panel().
    this-object:simpleButton2 = new DevExpress.XtraEditors.SimpleButton().
    this-object:simpleButton1 = new DevExpress.XtraEditors.SimpleButton().
    this-object:groupControl1 = new DevExpress.XtraEditors.GroupControl().
    this-object:Update_Fill_Panel:SuspendLayout().
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):BeginInit().
    this-object:SuspendLayout().
    /*  */
    /* Update_Fill_Panel */
    /*  */
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton2).
    this-object:Update_Fill_Panel:Controls:Add(this-object:simpleButton1).
    this-object:Update_Fill_Panel:Controls:Add(this-object:groupControl1).
    this-object:Update_Fill_Panel:Cursor = System.Windows.Forms.Cursors:Default.
    this-object:Update_Fill_Panel:Dock = System.Windows.Forms.DockStyle:Fill.
    this-object:Update_Fill_Panel:Location = new System.Drawing.Point(0, 0).
    this-object:Update_Fill_Panel:Name = "Update_Fill_Panel".
    this-object:Update_Fill_Panel:Size = new System.Drawing.Size(665, 461).
    this-object:Update_Fill_Panel:TabIndex = 0.
    /*  */
    /* simpleButton2 */
    /*  */
    this-object:simpleButton2:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    this-object:simpleButton2:Location = new System.Drawing.Point(578, 426).
    this-object:simpleButton2:Name = "simpleButton2".
    this-object:simpleButton2:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton2:TabIndex = 21.
    this-object:simpleButton2:Text = "C&ancel".
    this-object:simpleButton2:Click:Subscribe(this-object:simpleButton2_Click).
    /*  */
    /* simpleButton1 */
    /*  */
    this-object:simpleButton1:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:simpleButton1:Location = new System.Drawing.Point(497, 426).
    this-object:simpleButton1:Name = "simpleButton1".
    this-object:simpleButton1:Size = new System.Drawing.Size(75, 23).
    this-object:simpleButton1:TabIndex = 20.
    this-object:simpleButton1:Text = "&Save".
    this-object:simpleButton1:Click:Subscribe(this-object:simpleButton1_Click).
    /*  */
    /* groupControl1 */
    /*  */
    this-object:groupControl1:Location = new System.Drawing.Point(12, 12).
    this-object:groupControl1:Name = "groupControl1".
    this-object:groupControl1:ShowCaption = false.
    this-object:groupControl1:Size = new System.Drawing.Size(643, 399).
    this-object:groupControl1:TabIndex = 8.
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiRegion).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelRegion).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiState).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelState).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:uiStateName).
    THIS-OBJECT:groupControl1:Controls:Add(THIS-OBJECT:labelStateName).
THIS-OBJECT:groupControl1:Text = "groupControl1".
CAST(THIS-OBJECT:uiRegion:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
CAST(THIS-OBJECT:uiState:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
CAST(THIS-OBJECT:uiStateName:Properties, System.ComponentModel.ISupportInitialize):BeginInit().
/*  */
/* uiState */
/*  */
THIS-OBJECT:uiState:Location = NEW System.Drawing.Point(70, 9).
THIS-OBJECT:uiState:Name = "State".
THIS-OBJECT:uiState:Size = NEW System.Drawing.Size(100, 20).
THIS-OBJECT:uiState:TabIndex = 3.
/*  */
/* labelState */
/*  */
THIS-OBJECT:labelState:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelState:Location = NEW System.Drawing.Point(37, 10).
THIS-OBJECT:labelState:Name = "labelState".
THIS-OBJECT:labelState:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelState:TabIndex = 2.
THIS-OBJECT:labelState:Text = "State:".
/*  */
/* uiStateName */
/*  */
THIS-OBJECT:uiStateName:Location = NEW System.Drawing.Point(70, 35).
THIS-OBJECT:uiStateName:Name = "StateName".
THIS-OBJECT:uiStateName:Size = NEW System.Drawing.Size(200, 20).
THIS-OBJECT:uiStateName:TabIndex = 5.
/*  */
/* labelStateName */
/*  */
THIS-OBJECT:labelStateName:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelStateName:Location = NEW System.Drawing.Point(10, 36).
THIS-OBJECT:labelStateName:Name = "labelStateName".
THIS-OBJECT:labelStateName:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelStateName:TabIndex = 4.
THIS-OBJECT:labelStateName:Text = "StateName:".
/*  */
/* uiRegion */
/*  */
THIS-OBJECT:uiRegion:Location = NEW System.Drawing.Point(70, 61).
THIS-OBJECT:uiRegion:Name = "Region".
THIS-OBJECT:uiRegion:Size = NEW System.Drawing.Size(100, 20).
THIS-OBJECT:uiRegion:TabIndex = 7.
/*  */
/* labelRegion */
/*  */
THIS-OBJECT:labelRegion:AutoSizeMode = DevExpress.XtraEditors.LabelAutoSizeMode:Horizontal.
THIS-OBJECT:labelRegion:Location = NEW System.Drawing.Point(30, 62).
THIS-OBJECT:labelRegion:Name = "labelRegion".
THIS-OBJECT:labelRegion:Size = NEW System.Drawing.Size(26, 13).
THIS-OBJECT:labelRegion:TabIndex = 6.
THIS-OBJECT:labelRegion:Text = "Region:".

    /*  */
    /* StateBaseUpdate */
    /*  */
    this-object:CancelButton = this-object:simpleButton2.
    this-object:ClientSize = new System.Drawing.Size(665, 461).
    this-object:Controls:Add(this-object:Update_Fill_Panel).
    this-object:FormBorderStyle = System.Windows.Forms.FormBorderStyle:FixedDialog.
    this-object:LookAndFeel:SkinName = "Office 2010 Blue".
    this-object:LookAndFeel:UseDefaultLookAndFeel = false.
    this-object:Name = "BaseUpdate".
    this-object:SizeGripStyle = System.Windows.Forms.SizeGripStyle:Hide.
    
    this-object:Load:Subscribe(this-object:StateUpdate_Load).
    this-object:FormClosed:Subscribe(this-object:BaseUpdate_FormClosed).
    this-object:Update_Fill_Panel:ResumeLayout(false).
    cast(this-object:groupControl1, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiRegion:Properties, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiState:Properties, System.ComponentModel.ISupportInitialize):EndInit().
    CAST(THIS-OBJECT:uiStateName:Properties, System.ComponentModel.ISupportInitialize):EndInit().
THIS-OBJECT:ResumeLayout(FALSE).
    catch e as Progress.Lang.Error:
      undo, throw e.
    end catch.
	end method.


	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void StateUpdate_Load( input sender as System.Object, input e as System.EventArgs ):

	  if not valid-object(State1) then return.
    
    assign uiRegion:text    = State1:Region
           uiState:text     = State1:State
           uiStateName:text = State1:StateName.
    
		return.

	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method protected void simpleButton1_Click( input sender as System.Object, input e as System.EventArgs ):
	  this-object:Save().
  end method.
  
  method protected void Save():		
           
    assign State1:Region    = uiRegion:Text
           State1:State     = uiState:Text
           State1:StateName = uiStateName:Text.
    
    do transaction on error undo, leave:
		  State1:Save().

      catch f as Progress.Lang.AppError:
        case f:GetMessageNum(1):
          otherwise message substitute ("Cannot save State [&1]",f:GetMessage(1)) view-as alert-box warning.
        end case.
       
        return .   
      end catch.
    end.
		
		this-object:DialogResult = System.Windows.Forms.DialogResult:OK.
    this-object:Close ( ).
    
		return.

	end method.


  method private void shutdown():
    this-object:DialogResult = System.Windows.Forms.DialogResult:Cancel.
    delete object this-object.
    return.
  end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	method private void simpleButton2_Click( input sender as System.Object, input e as System.EventArgs ):
    this-object:Close().
		return.

	end method.
    
  destructor public StateBaseUpdate ( ):

		if valid-object(components) then do:
			cast(components, System.IDisposable):Dispose().
		end.

	end destructor.

end class.
@BuildInfo(Source="./sports/_Maia-Config/State/_Config.xml").
@BuildInfo(Date="30/08/2011 08:37:31.995+01:00").